
/** @file
    @brief		R\[ǗNX
    @author		t`
    @since		2003.01.22
*/


//=============================================================================
// INCLUDE
//=============================================================================
#include "LunaBase.h"


#include "LunaConsole.h"

namespace lunadxmath{
//=============================================================================
// VARIABLE
//=============================================================================
bool LunaConsole::m_IsInit;
HANDLE LunaConsole::m_hConsole;


//=============================================================================
/**
	NX̐s܂

	@retval true		
	@retval false		s
*/
//=============================================================================
bool LunaConsole::Initialize( void )
{
	//Luna::LogoutMainCategory( "LunaConsoleNX̏" );
	//Luna::LogoutNextLine();

	return true;
}

//=============================================================================
/**
	NX̉s܂

*/
//=============================================================================
void LunaConsole::Finalize( void )
{
	//Luna::LogoutMainCategory( "LunaConsoleNX̉" );
	//Luna::LogoutNextLine();

	LunaConsole::Release();
}

//=============================================================================
/**
	R\[̐܂<BR>
	P̃AvP[Vɑ΂ĂPł܂

	@retval true		
	@retval false		s
*/
//=============================================================================
bool LunaConsole::Create( void )
{
	if ( !m_IsInit )
	{
		// R\[
		::AllocConsole();

		// R\[̃nh擾
		m_hConsole = ::GetStdHandle( STD_OUTPUT_HANDLE );
		m_IsInit = m_hConsole != NULL;
	}

	return m_IsInit;
}

//=============================================================================
/**
	R\[̉܂

*/
//=============================================================================
void LunaConsole::Release( void )
{
	if ( m_IsInit )
	{
		m_IsInit = false;

		// R\[̉
		::FreeConsole();
	}
}

//=============================================================================
/**
	R\[NA܂

*/
//=============================================================================
void LunaConsole::Clear( void )
{
	if ( m_IsInit )
	{
		CONSOLE_SCREEN_BUFFER_INFO ScInfo;
		Uint32 Written;
		COORD Pos = { 0, 0 };

		if ( ::GetConsoleScreenBufferInfo( m_hConsole, &ScInfo ) )
		{
			::FillConsoleOutputCharacter(
				m_hConsole,
				' ',
				ScInfo.dwSize.X * ScInfo.dwSize.Y,
				Pos,
				&Written );
		}
	}
}

//=============================================================================
/**
	R\[̃J[\ʒuݒ肵܂

	@param x		[in] R\[wʒu
	@param y		[in] R\[xʒu

*/
//=============================================================================
void LunaConsole::Locate( Sint32 x, Sint32 y )
{
	if ( m_IsInit )
	{
		COORD Pos = { (Sint16)x, (Sint16)y };

		::SetConsoleCursorPosition( m_hConsole, Pos );
	}
}

//=============================================================================
/**
	R\[ɏo͂܂

	@param pStr		[in] o͕iprintfɏj
*/
//=============================================================================
void LunaConsole::Print( const char *pStr,... )
{
	if ( m_IsInit )
	{
		Uint32 WriteSize;
		char Temp[1024] = "";

		// 񐶐
		vsprintf( Temp, pStr, (char*)(&pStr + 1) );

		// R\[ɏo
		::WriteFile( m_hConsole, Temp, (Sint32)strlen(Temp), &WriteSize, 0 );
	}
}

//=============================================================================
/**
	R\[Ɉʒuwďo͂܂

	@param x		[in] R\[wʒu
	@param y		[in] R\[xʒu
	@param pStr		[in] o͕iprintfɏj
*/
//=============================================================================
void LunaConsole::Print( Sint32 x, Sint32 y, const char *pStr,... )
{
	if ( m_IsInit )
	{
		Uint32 WriteSize;
		char Temp[1024] = "";

		LunaConsole::Locate( x, y );

		// 񐶐
		vsprintf( Temp, pStr, (char*)(&pStr + 1) );

		// R\[ɏo
		::WriteFile( m_hConsole, Temp, (Sint32)strlen(Temp), &WriteSize, 0 );
	}
}

//=============================================================================
/**
	R\[̐Fݒ肵܂

	@param Attributes	[in] ȉ̃tȎgݍ킹ɂȂ܂<BR>
								OiF						<BR>
									FOREGROUND_BLUE			<BR>
									FOREGROUND_GREEN		<BR>
									FOREGROUND_RED			<BR>
									FOREGROUND_INTENSITY	<BR>
								wiF						<BR>
									BACKGROUND_BLUE			<BR>
									BACKGROUND_GREEN		<BR>
									BACKGROUND_RED			<BR>
									BACKGROUND_INTENSITY 	<BR>
*/
//=============================================================================
void LunaConsole::SetColor( Uint16 Attributes )
{
	if ( m_IsInit )
	{
		::SetConsoleTextAttribute( m_hConsole, Attributes );
	}
}

//=============================================================================
/**
	R\[̃J[\\ɂ܂

*/
//=============================================================================
void LunaConsole::CursorOff( void )
{
	if ( m_IsInit )
	{
		CONSOLE_CURSOR_INFO cinfo;

		::GetConsoleCursorInfo( m_hConsole, &cinfo );

		cinfo.bVisible = false;
		::SetConsoleCursorInfo( m_hConsole, &cinfo );
	}
}

//=============================================================================
/**
	R\[̃J[\\܂

*/
//=============================================================================
void LunaConsole::CursorOn( void )
{
	if ( m_IsInit )
	{
		CONSOLE_CURSOR_INFO cinfo;

		::GetConsoleCursorInfo( m_hConsole, &cinfo );

		cinfo.bVisible = true;
		::SetConsoleCursorInfo( m_hConsole, &cinfo );
	}
}

}//eon
